<?php
/** -------------------------------------------------------
 *
 *   LiveStreet (v1.x)
 *   Plugin Guest comments uLogin (v.1.0)
 *   Copyright © 2015 Bishovec Nikolay
 *
 * --------------------------------------------------------
 *
 *   Plugin Page: http://netlanc.net
 *   Contact e-mail: netlanc@yandex.ru
 *
 * ---------------------------------------------------------
 */

class PluginUlc_ActionBlog extends PluginUlc_Inherit_ActionBlog
{
    protected function SubmitComment()
    {
        $bGuest = false;
        $sGuestNetwork = null;
        $sGuestUrl = null;
        $sGuestName = null;
        $sGuestAvatar = null;

        if (!$this->User_IsAuthorization()) {
            $this->oUserCurrent = $this->User_GetUserByLogin('guest');
            $bGuest = true;

            $aUlt = array();
            if (!empty($_COOKIE['ult'])) {
                $aUlt = json_decode($_COOKIE['ult'], true);
            }

            if (empty($aUlt['network']) || empty($aUlt['uid']) || empty($aUlt['token'])) {
                $this->Viewer_AssignAjax('logout_uLogin', true);
                $this->Message_AddErrorSingle($this->Lang_Get('plugin.ulc.error_aut'), $this->Lang_Get('error'));
                return;
            }

            if (!($oSession = $this->PluginUlc_Ulogin_GetSessionByNetworkByUidByTime($aUlt['network'], $aUlt['uid'], time() - Config::Get('plugin.ulc.token_time')))) {

                $sUrl = 'http://ulogin.ru/token.php?token=' . $aUlt['token'] . '&host=' . Config::Get('path.root.web');
                $s = file_get_contents($sUrl);
                $aULogin = json_decode($s, true);

                $this->Viewer_AssignAjax('aULogin', $aULogin);
                if (empty($aULogin) || !empty($aULogin['error'])) {
                    $this->Viewer_AssignAjax('logout_uLogin', true);
                    $this->Message_AddErrorSingle($this->Lang_Get('plugin.ulc.error_aut_token'), $this->Lang_Get('error'));
                    return;
                }

                $sGuestNetwork = $aULogin['network'];
                $sGuestUrl = $aULogin['identity'] ;
                $sGuestAvatar = $aULogin['photo'];

                $sGuestName = $aULogin['first_name'];
                $sGuestName .= !empty($aULogin['last_name']) ? ' ' . $aULogin['last_name']:'';

                if ($sGuestNetwork == 'youtube'){

                    if ($sXmlData = @file_get_contents($sGuestUrl)){
                        $dom = new domDocument;
                        @$dom->loadXML($sXmlData);
                        $dom->preserveWhiteSpace = false;

                        $sGuestUrl = $dom->getElementsByTagName('link')->item(0)->attributes->item(2)->nodeValue;
                    }

                }


                $oSessionNew = Engine::GetEntity('PluginUlc_Ulogin_Session');
                $oSessionNew->setUloginToken($aUlt['token']);
                $oSessionNew->setUloginNetwork($sGuestNetwork);
                $oSessionNew->setUloginUid($aULogin['uid']);
                $oSessionNew->setUloginName($sGuestName);
                $oSessionNew->setUloginPhoto($sGuestAvatar);
                $oSessionNew->setUloginUrl($sGuestUrl);
                $oSessionNew->setTimeAdd(time());

                $this->PluginUlc_Ulogin_AddSession($oSessionNew);

            } else {

                $sGuestNetwork = $oSession->getUloginNetwork();
                $sGuestUrl = $oSession->getUloginUrl();
                $sGuestName = $oSession->getUloginName();
                $sGuestAvatar = $oSession->getUloginPhoto();

            }

        }
        /**
         * Проверяем топик
         */
        if (!($oTopic = $this->Topic_GetTopicById(getRequest('cmt_target_id')))) {
            $this->Message_AddErrorSingle($this->Lang_Get('system_error'), $this->Lang_Get('error'));
            return;
        }
        /**
         * Возможность постить коммент в топик в черновиках
         */
        if (!$oTopic->getPublish() and $this->oUserCurrent->getId() != $oTopic->getUserId() and !$this->oUserCurrent->isAdministrator()) {
            $this->Message_AddErrorSingle($this->Lang_Get('system_error'), $this->Lang_Get('error'));
            return;
        }
        /**
         * Проверяем разрешено ли постить комменты
         */
        if (!$bGuest and !$this->ACL_CanPostComment($this->oUserCurrent) and !$this->oUserCurrent->isAdministrator()) {
            $this->Message_AddErrorSingle($this->Lang_Get('topic_comment_acl'), $this->Lang_Get('error'));
            return;
        }
        /**
         * Проверяем разрешено ли постить комменты по времени
         */
        if (!$bGuest and !$this->ACL_CanPostCommentTime($this->oUserCurrent) and !$this->oUserCurrent->isAdministrator()) {
            $this->Message_AddErrorSingle($this->Lang_Get('topic_comment_limit'), $this->Lang_Get('error'));
            return;
        }
        /**
         * Проверяем запрет на добавления коммента автором топика
         */
        if ($oTopic->getForbidComment()) {
            $this->Message_AddErrorSingle($this->Lang_Get('topic_comment_notallow'), $this->Lang_Get('error'));
            return;
        }
        /**
         * Проверяем текст комментария
         */
        if ($bGuest) {
            $sText = nl2br(strip_tags(getRequest('comment_text')));
        } else {
            $sText = $this->Text_Parser(getRequest('comment_text'));
        }
        if (!func_check($sText, 'text', 2, 10000)) {
            $this->Message_AddErrorSingle($this->Lang_Get('topic_comment_add_text_error'), $this->Lang_Get('error'));
            return;
        }
        /**
         * Проверям на какой коммент отвечаем
         */
        $sParentId = (int)getRequest('reply');
        if (!func_check($sParentId, 'id')) {
            $this->Message_AddErrorSingle($this->Lang_Get('system_error'), $this->Lang_Get('error'));
            return;
        }
        $oCommentParent = null;
        if ($sParentId != 0) {
            /**
             * Проверяем существует ли комментарий на который отвечаем
             */
            if (!($oCommentParent = $this->Comment_GetCommentById($sParentId))) {
                $this->Message_AddErrorSingle($this->Lang_Get('system_error'), $this->Lang_Get('error'));
                return;
            }
            /**
             * Проверяем из одного топика ли новый коммент и тот на который отвечаем
             */
            if ($oCommentParent->getTargetId() != $oTopic->getId()) {
                $this->Message_AddErrorSingle($this->Lang_Get('system_error'), $this->Lang_Get('error'));
                return;
            }
        } else {
            /**
             * Корневой комментарий
             */
            $sParentId = null;
        }
        /**
         * Проверка на дублирующий коммент
         */
        if ($this->Comment_GetCommentUnique($oTopic->getId(), 'topic', $this->oUserCurrent->getId(), $sParentId, md5($sText))) {
            $this->Message_AddErrorSingle($this->Lang_Get('topic_comment_spam'), $this->Lang_Get('error'));
            return;
        }
        /**
         * Создаём коммент
         */
        $oCommentNew = Engine::GetEntity('Comment');
        $oCommentNew->setDomain($oTopic->getDomain());
        $oCommentNew->setTargetId($oTopic->getId());
        $oCommentNew->setTargetType('topic');
        $oCommentNew->setTargetParentId($oTopic->getBlog()->getId());
        $oCommentNew->setUserId($this->oUserCurrent->getId());
        $oCommentNew->setText($sText);
        $oCommentNew->setDate(date("Y-m-d H:i:s"));
        $oCommentNew->setUserIp(func_getIp());
        $oCommentNew->setPid($sParentId);
        $oCommentNew->setTextHash(md5($sText));
        $oCommentNew->setPublish($oTopic->getPublish());


        $oCommentNew->setGuestNetwork($sGuestNetwork);
        $oCommentNew->setGuestUrl($sGuestUrl);

        $oCommentNew->setGuestName($sGuestName);
        $oCommentNew->setGuestAvatar($sGuestAvatar);

        /**
         * Добавляем коммент
         */
        $this->Hook_Run('comment_add_before', array('oCommentNew' => $oCommentNew, 'oCommentParent' => $oCommentParent, 'oTopic' => $oTopic));
        if ($this->Comment_AddComment($oCommentNew)) {
            $this->Hook_Run('comment_add_after', array('oCommentNew' => $oCommentNew, 'oCommentParent' => $oCommentParent, 'oTopic' => $oTopic));

            if ($bGuest) {
                $this->Comment_UpdateCommentGuest($oCommentNew);
            }

            $this->Viewer_AssignAjax('sCommentId', $oCommentNew->getId());
            if ($oTopic->getPublish()) {
                /**
                 * Добавляем коммент в прямой эфир если топик не в черновиках
                 */
                $oCommentOnline = Engine::GetEntity('Comment_CommentOnline');
                $oCommentOnline->setDomain($oTopic->getDomain());
                $oCommentOnline->setTargetId($oCommentNew->getTargetId());
                $oCommentOnline->setTargetType($oCommentNew->getTargetType());
                $oCommentOnline->setTargetParentId($oCommentNew->getTargetParentId());
                $oCommentOnline->setCommentId($oCommentNew->getId());

                $this->Comment_AddCommentOnline($oCommentOnline);
            }
            /**
             * Сохраняем дату последнего коммента для юзера
             */
            $this->oUserCurrent->setDateCommentLast(date("Y-m-d H:i:s"));
            $this->User_Update($this->oUserCurrent);

            /**
             * Список емайлов на которые не нужно отправлять уведомление
             */
            $aExcludeMail = array($this->oUserCurrent->getMail());
            /**
             * Отправляем уведомление тому на чей коммент ответили
             */
            if ($oCommentParent and $oCommentParent->getUserId() != $oTopic->getUserId() and $oCommentNew->getUserId() != $oCommentParent->getUserId()) {
                $oUserAuthorComment = $oCommentParent->getUser();
                $aExcludeMail[] = $oUserAuthorComment->getMail();
                $this->Notify_SendCommentReplyToAuthorParentComment($oUserAuthorComment, $oTopic, $oCommentNew, $this->oUserCurrent);
            }
            /**
             * Отправка уведомления автору топика
             */
            $this->Subscribe_Send('topic_new_comment', $oTopic->getId(), 'notify.comment_new.tpl', $this->Lang_Get('notify_subject_comment_new'), array(
                'oTopic' => $oTopic,
                'oComment' => $oCommentNew,
                'oUserComment' => $this->oUserCurrent,
            ), $aExcludeMail);
            /**
             * Добавляем событие в ленту
             */
            $this->Stream_write($oCommentNew->getUserId(), 'add_comment', $oCommentNew->getId(), $oTopic->getPublish() && $oTopic->getBlog()->getType() != 'close');
        } else {
            $this->Message_AddErrorSingle($this->Lang_Get('system_error'), $this->Lang_Get('error'));
        }

    }

    protected function AjaxResponseComment()
    {
        if (!$this->oUserCurrent) {
            $this->oUserCurrent = $this->User_GetUserByLogin('guest');
        }
        parent::AjaxResponseComment();
    }
}

?>