<?php
/** -------------------------------------------------------
 *
 *   LiveStreet (v1.x)
 *   Plugin Guest comments uLogin (v.1.0)
 *   Copyright © 2015 Bishovec Nikolay
 *
 * --------------------------------------------------------
 *
 *   Plugin Page: http://netlanc.net
 *   Contact e-mail: netlanc@yandex.ru
 *
 * ---------------------------------------------------------
 */

class PluginUlc_ModuleUlogin_MapperUlogin extends Mapper
{
    public function AddSession(PluginUlc_ModuleUlogin_EntitySession $oSession) {
        $sql = "INSERT INTO " . Config::Get('plugin.ulc.table.ulogin_session') . "
                    (
                        ulogin_token,
                        ulogin_network,
                        ulogin_uid,
                        ulogin_name,
                        ulogin_photo,
                        ulogin_url,
                        session_time_add
                    )
                    VALUES(?, ?, ?, ?, ?, ?, ?d)
                ";
        if ($iId=$this->oDb->query($sql, $oSession->getUloginToken(), $oSession->getUloginNetwork(), $oSession->getUloginUid(), $oSession->getUloginName(), $oSession->getUloginPhoto(), $oSession->getUloginUrl(), $oSession->getTimeAdd()))
        {
            return $iId;
        }
        return false;
    }

    public function UpdateSession(PluginUlc_ModuleUlogin_EntitySession $oSession) {
        $sql = "UPDATE " . Config::Get('plugin.ulc.table.ulogin_session') . "
                    SET
                        session_time_edit	 = ?
                    WHERE session_id = ?d
                ";
        if ($this->oDb->query($sql, $oSession->getTimeEdit(), $oSession->getId()))
        {
            return true;
        }
        return false;
    }

    public function DeleteSession($sId) {
        $sql = "DELETE FROM " . Config::Get('plugin.ulc.table.ulogin_session') . " WHERE session_id = ?d";
        if ($aRow=$this->oDb->selectRow($sql, $sId)) {
            return true;
        }
        return false;
    }

    public function GetSessionByNetworkByUidByTime($sNetwork, $sUid, $sTime) {
        $sql = "SELECT * FROM " . Config::Get('plugin.ulc.table.ulogin_session') . " WHERE ulogin_network = ? AND ulogin_uid = ? AND session_time_add > ?d";
        if ($aRow=$this->oDb->selectRow($sql, $sNetwork, $sUid, $sTime)) {
            return Engine::GetEntity('PluginUlc_Ulogin_Session', $aRow);
        }
        return null;
    }

    public function GetSessionById($sId) {
        $sql = "SELECT * FROM " . Config::Get('plugin.ulc.table.ulogin_session') . " WHERE session_id = ? ";
        if ($aRow=$this->oDb->selectRow($sql, $sId)) {
            return Engine::GetEntity('PluginUlc_Ulogin_Session', $aRow);
        }
        return null;
    }

}

?>
